#include <exception>
#include <iostream>
#include <QtGui/QApplication>
#include "panoramaWindow.hh"
#include <fstream>
#include <mimas/image_fileinput.h>
#include <GL/glut.h>
#include <QtOpenGL/QGLWidget>
#include <QtGui/QColor>
#include <QtGui/QKeyEvent>
#include <vector>

using namespace std;
using namespace mimas;

int main( int argc, char *argv[] ){


  int retVal = 0;

  // Initialise GLUT.
  glutInit( &argc, argv );

  QApplication app( argc, argv );

  try {

    QGLFormat fmt;
    fmt.setAlpha( true );
    // fmt.setAccum( true );// ?
    // fmt.setOverlay( true );
    // fmt.setSampleBuffers ( true );
    QGLFormat::setDefaultFormat( fmt );

    /* MMERROR( argc >= 2, mimasexception, ,
             "Syntax: " << argv[0] << " <image1> [<image2> ...]" );
    vector< image< rgba< unsigned char > > > images;
    for ( int i=1; i<argc; i++ ) {

      ifstream f( argv[i], ios::binary );
      image< rgba< unsigned char > > _img;
      MMERROR( f >> img, mimasexception, , "Error loading image \""
               << argv[1] << "\"." );
      // Make image transparent.
      for ( int y=0; y<img.getHeight(); y++ )
        for ( int x=0; x<img.getWidth(); x++ ) {
          img.pixel( x, y ).setAlpha( 192 );
        };
      images.push_back( _img );
    };
    TextureDisplay window( images ); */
    PanoramaWindow window;
    window.resize( 640, 400 );
    window.show();
    retVal = app.exec();
    
  } catch ( exception &e ) {

    cerr << e.what() << endl;
    retVal = 1;

  };

  return retVal;
}
