#include <fstream>
#include <mimas/image_fileinput.h>
#include <QtGui/QFileDialog>
#include <QtGui/QMessageBox>
#include "panoramaWindow.hh"
#include <iostream>
#include <fstream>
#include <sstream>


using namespace mimas;
using namespace std;



/*typedef struct YPR {
   double yaw;
   double pitch;
   double roll; 
};


typedef struct ControlPoints {
   double x;
   double y
   double index;
};

std::vector<YPR>angles;
std::vector<std::pair<ControlPoint, ControlPoint>>Control;
*/



PanoramaWindow::PanoramaWindow( QWidget *parent, Qt::WFlags f ):
  QWidget( parent, f )
{
  ui.setupUi( this );
  connect( ui.loadButton, SIGNAL(clicked()), this, SLOT(loadImage()) ); //el boton es loadImage
  connect( ui.closeButton, SIGNAL(clicked()), this, SLOT(close()) );
  connect( ui.yawbutton, SIGNAL(valueChanged(double)), this, SLOT(rotateyaw(double)));
  connect( ui.rollbutton, SIGNAL(valueChanged(double)), this, SLOT(rotateroll(double)));
  connect( ui.pitchbutton, SIGNAL(valueChanged(double)), this, SLOT(rotatepitch(double)));
  connect( ui.imageProperties, SIGNAL(clicked()), this, SLOT(readpto()));
  

}



void PanoramaWindow::loadImage(void)
{
  QString fileName =
    QFileDialog::getOpenFileName( this, "Load Image", QString(),
                                  "Images (*.png *.jpg *.bmp);;All Files (*)" );
  if ( !fileName.isEmpty() ) {

    try {

      ifstream f( fileName.toLatin1(), ios::binary );
      image< rgba< unsigned char > > img;
      MMERROR( f >> img, mimasexception, ,
               "Error loading file \"" << (const char *)fileName.toLatin1()
               << "\"." );
      ui.display->addImage( img );
    } catch ( exception &e ) {
      
      QMessageBox::critical( this, "Error loading image",
                             e.what() );

    };

  };
};

void PanoramaWindow::rotateyaw( double d )
{
  cerr << "Yaw" << endl;
  cerr << d << endl;
  ui.display->setYaw( d * M_PI / 180.0 );
}

void PanoramaWindow::rotateroll( double d )
{
  cerr << "Roll" << endl;
  cerr << d << endl;
  ui.display->setRoll( d * M_PI / 180.0 );
}

void PanoramaWindow::rotatepitch( double d )
{
  cerr << "Pitch" << endl;
  cerr << d << endl;
  ui.display->setPitch( d * M_PI / 180.0 );
}


//Read the pto file


void PanoramaWindow:: readpto(){

   
   string str;
   std::vector<std::string> line;
   float _hfov = 0.0;


//OPEN PTO FILE

    QString fileName =
    QFileDialog::getOpenFileName( this, "Load Pto File", QString(),
                                  "Pto Files (*.pto);;All Files (*)" );
    if ( !fileName.isEmpty() ) {

       ifstream f( fileName.toLatin1() ); 

       while(f) {
	
          string cadena;
          getline( f, cadena, '\n');


     
// IDENTIFY IMAGE



    if ( cadena[0] == 'i' ) {

        int pos = cadena.rfind( "n\"" );
        cout << endl << endl << "IMAGE NAME--> " << cadena.substr( pos + 2, cadena.length() - pos - 3 ) << endl << endl;
        
	//Opening the identified image

	string fileName = cadena.substr( pos + 2, cadena.length() - pos - 3 );

        ifstream file( fileName.c_str(), ios::binary );
        image< rgba< unsigned char > > img;
        MMERROR( file >> img, mimasexception, ,
                 "Error loading file \"" << fileName.c_str()
                 << "\"." );
        //ui.display->addImage( img );
        // getchar();
     }

   
// GET PITCH
    

          istringstream spitch, sroll, syaw, scontrolx1, scontroly1, scontrolx2, scontroly2, shfov( cadena );
          string str;
          spitch >> str;
          if ( cadena == "i" ) {
	   
              for ( int i=0; i<21; i++ ) {
		    string temp;
		    spitch >> temp;
	      };
	      string pitch;
              spitch >> pitch;
              cout << "PITCH --> " << atof( pitch.substr( 1, pitch.length() - 1 ).c_str() ) << endl;
              float  _pitch=atof(pitch.substr( 1, pitch.length() - 1 ).c_str() );
              cout << _pitch << endl;
              getchar();
          }


      
// GET YAW

        string str2;
        syaw >> str2;
        if ( str2 == "i" ) {
	      
           for ( int i=0; i<25; i++ ) {
		      string temp2;
		      syaw >> temp2;
	   };
	   string yaw;
           syaw >> yaw;
           cout << "YAW--> " << atof( yaw.substr( 1, yaw.length() - 1 ).c_str() ) << endl;
      }


// GET ROLL
  

       string str3;
       sroll >> str3;
       if ( str3 == "i" ) {
	
          for ( int i=0; i<22; i++ ) {
		      string temp3;
		      sroll >> temp3;
	  };
	  string roll;
          sroll >> roll;
          cout << "ROLL--> " << atof( roll.substr( 1, roll.length() - 1 ).c_str() ) << endl;
      }


//GET CONTROL POINTS

        //Get X1
        string str4;
        scontrolx1 >> str4;

        if ( str4 == "c" ) {
	
          for ( int i=0; i<2; i++ ) {
		      string temp4;
		      scontrolx1 >> temp4;
                      
	  };
          
	string controlx1;
        scontrolx1 >> controlx1;
        cout << "CONTROL POINTS IMAGE 1 --> X1 " << atof( controlx1.substr( 1, controlx1.length() - 1 ).c_str() ) << endl;
        }

        
        //Get Y1
     
        string str5;
        scontroly1 >> str5;

        if ( str5 == "c" ) {
	
          for ( int i=0; i<3; i++ ) {
		      string temp5;
		      scontroly1 >> temp5;
                      
	  };
          
	string controly1;
        scontroly1 >> controly1;
        cout << "CONTROL POINTS IMAGE 1 --> Y1 " << atof( controly1.substr( 1, controly1.length() - 1 ).c_str() ) << endl;
        }


        //Get X2

        string str6;
        scontrolx2 >> str6;

        if ( str6 == "c" ) {
	
          for ( int i=0; i<4; i++ ) {
		      string temp6;
		      scontrolx2 >> temp6;
                      
	  };
          
	string controlx2;
        scontrolx2 >> controlx2;
        cout << "CONTROL POINTS IMAGE 2 --> X2 " << atof( controlx2.substr( 1, controlx2.length() - 1 ).c_str() ) << endl;
        }



        //Get Y2
     
        string str7;
        scontroly2 >> str7;

        if ( str7 == "c" ) {
	
          for ( int i=0; i<5; i++ ) {
		      string temp7;
		      scontroly2 >> temp7;
                      
	  };
          
	string controly2;
        scontroly2 >> controly2;
        cout << "CONTROL POINTS IMAGE 2 --> Y2 " << atof( controly2.substr( 1, controly2.length() - 1 ).c_str() ) << endl;
        }

       



//GET HFOV


        string str8;
        shfov >> str8;
        if ( str8 == "i" ) {
	      
           for ( int i=0; i<24; i++ ) {
		      string temp8;
		      shfov >> temp8;
	   };
	   string hfov;
           shfov >> hfov;
           cout << "HFOV--> " << atof( hfov.substr( 1, hfov.length() - 1 ).c_str() ) << endl << endl;
           float value =atof(hfov.substr( 1, hfov.length() - 1 ).c_str() );
           if ( value > 0.0 ) _hfov = value;
           cout << _hfov << endl;
           getchar();
          }

      }
   }   
}





